# Cellular Automaton
  
A simple platform for playing with Cellular Automaton by jimmyff. Happily accepting pull requests! ^_^
  
 * Github: [https://github.com/jimmyff/cellular_automaton](https://github.com/jimmyff/cellular_automaton)
 * Dart Pub: [https://pub.dartlang.org/packages/cellular_automaton](https://pub.dartlang.org/packages/cellular_automaton)
 * Demos: [http://jimmyff.github.io/cellular_automaton](http://jimmyff.github.io/cellular_automaton)
  
## Features

 * Generators to seed the simulation
 * Current renderers:
   * StageXL: WebGL, fullscreen support
  
## Implemented rules/simulations
  
 * Conway's Game of Life
  
## Demos
  
See the `demos/` folder for demos. You can try the [hosted demos](http://jimmyff.github.io/cellular_automaton) here.
  
## Roadmap

 * Add tests
 * Performance information
 * Implement additional CA rules (Brain, Voting, WireWorld etc)
 * Detect stale simulations for reset / next
 * Playlist of simulations
 * Transitions for switching between two simulations
 * Multiple simulations/rule-sets running in a single scene
 * Generated color palettes
 * Simulation controls (pause, reset, speed etc)
 * Interactive mode (edit mode)
 * Analysis tools (histograms for state counts)
 * Add an LED Matrix renderer for raspberry pi using GPIO pins
 * Flutter renderer
 * CLI renderer
 * Infinite world size support
  
## Licence
   
Please see the [cellular_automaton license](https://github.com/jimmyff/cellular_automaton/blob/master/LICENSE).